#!/usr/bin/env python3

#
# Create a new text document, insert text
# Save as ODT
#

#
# Purpose: how can we use UNO connection to LibreOffice?
#
#

from LO.server      import LO_server
from LO.save        import saveTextAsOdt
from LO.text_new    import newTextDocument

# a UNO struct later needed to create a document
# from com.sun.star.beans import PropertyValue
from com.sun.star.awt.FontWeight import BOLD
from com.sun.star.awt.FontSlant  import ITALIC


import time # for sleep
#import socket  # only needed on win32-OOo3.0.0

print("Create server")
Hidden=False # shall we hide GUI?
doSleep=not Hidden;

with LO_server( PREFIX = "/usr/lib/libreoffice/program" ,
                PORT   = 'pipe,name=mypipename'         ,
                Hidden = Hidden                         ) as lo:

    print("newTextDocument, text, cursor")
    # get the central desktop object
    # desktop = lo.desktop

    model = newTextDocument( lo.desktop, Hidden=Hidden )

    # access the document's text property
    text = model.Text

    # create a cursor
    cursor = text.createTextCursor()

    #
    # *** TEST ***
    #
    text.insertString( cursor, "(upright black)" , 0 )

    cursor.setPropertyValue( "CharColor", 0xff4040 )
    cursor.setPropertyValue( "CharPosture", ITALIC )
    text.insertString( cursor, "(color italic)" , 0 )

    cursor.setPropertyToDefault( "CharPosture") ## removes italic (OK), but removes CharColor as well (not OK)
    text.insertString( cursor, "(upright, should have color)" , 0 )    ## lost the color


    odt_filename="aa.odt"
    print("write %s" % odt_filename)
    saveTextAsOdt( model, odt_filename )

    #
    #time.sleep(5)
    #

    print("cleanup: model, lo")
    model.dispose()


    # Do a nasty thing before exiting the python process. In case the
    # last call is a oneway call (e.g. see idl-spec of insertString),
    # it must be forced out of the remote-bridge caches before python
    # exits the process. Otherwise, the oneway call may or may not reach
    # the target object.
    # I do this here by calling a cheap synchronous call (getPropertyValue).
    lo.ctx.ServiceManager
    pass

# lo.stop()

##server_stop(PREFIX, PORT, server_proc)

print("Finished")
